@echo off
:: Determine the correct registry path for HKLM.
set "sourceKey=HKLM\Software\WOW6432Node\Gameware Development\Creatures 1\1.0"
reg query "%sourceKey%" >nul 2>&1
if errorlevel 1 (
    set "sourceKey=HKLM\Software\Gameware Development\Creatures 1\1.0"
)

:: Copy HKLM to HKCU for Millennium Interactive and Creatures. (not Creatures 1)
reg copy "%sourceKey%" "HKCU\Software\Millennium Interactive\Creatures\1.0" /s /f

:: Get the install directory.
for /f "skip=2 tokens=1,2,3,*" %%A in ('reg query "%sourceKey%" /v "Main Directory"') do (
    if "%%A %%B"=="Main Directory" set "maindir=%%D"
)
echo Main Directory: %maindir%

:: Copy palette.dta to palette so the new injector can find it.
copy "%maindir%\Palettes\palette.dta" "%maindir%\Palettes\palette" /Y

:: Backup the old injector.
if exist "%maindir%\Injector.exe" (
    echo Backing up existing Injector.exe...
    rename "%maindir%\Injector.exe" "Old_Injector.exe"
)

:: Copy new files.
xcopy "Injector\*.*" "%maindir%\" /S /Y

:: Launch the injector to get the Defender prompt out of the way.
start "" "%maindir%\Injector.exe"


echo Done! Your game is now using the latest object injector.
pause